﻿# -*- coding: utf-8 -*-
"""
無効な項目に入力があった場合にエラーとします。
"""

import cse
import cseMessageBox


# 出力シートチェックメソッド
def CheckOutSheet(s, e):
  # プラグイン実行イベントデータ
  v = e.Value
  
  # エラーの種類
  errtype = "ERR_DisablingFilled"
  
  for sti in v.sheets:
    # 見えるチェックシートのみ
    if not sti.IsShown:
      continue
    
    # 親側、子側実装コンテンツでループ
    for contset in cse.getcontssets(sti.Sheet, False):
      # 無効セルをリストアップし、入力のあるものをエラーとする
      for cont in cse.getdisabledlist(contset):
        if not cont.IsEmpty:
          v.errors.append({'type': errtype, 'path': cse.deparsepath(cont), 'nooutput': True})
    



# 入力シートチェックメソッド
def CheckImportedSheet(s, e):
  # プラグイン実行イベントデータ
  v = e.Value
  
  # 無効なセルの入力がなくなるまでループ
  while True:
    disablingFilledCells = []
    
    # SheetTabInfo ごとにループ
    for sti in v.sheets:
      # 親側、子側実装コンテンツでループ
      for contset in cse.getcontssets(sti.Sheet, False):
        # 無効セルをリストアップし、入力のあるものをエラーとする
        for cont in cse.getdisabledlist(contset):
          if not cont.IsEmpty:
            disablingFilledCells.append(cont)
    
    # 無効なセルに入力があって、ダイアログで「はい」を選択したら、全て削除する
    if len(disablingFilledCells) > 0:
      # ダイアログメッセージを作成 (無効なセルの先頭の 32 要素を)
      errtargets = "\n".join("  " + cse.getcellpathtitle(str(cont.Path)) for cont in disablingFilledCells[:32])
      errmsg = cse.getapplang("PlgMsg_ChkDsbl_AllClear") % errtargets
      if len(disablingFilledCells) > 32:
        # 省略した数の表示
        errmsg += "\n  and more... (%d)" % (len(disablingFilledCells) - 32)
      
      if cseMessageBox.askyesno("", errmsg):
        for cont in disablingFilledCells:
          cont.Clear()
        # もう一度
        continue
    
    # 無効なセルに入力がなかったり、ダイアログで「いいえ」を選択したら、ループを抜ける
    break


cse.addhandler("RequestCheckOutSheet", CheckOutSheet)
cse.addhandler("AfterFileImported", CheckImportedSheet)
